#!/usr/bin/perl
# -----------------------------------------------------------------------------
#   ident "@(#)jdk.pl 1.17 04/09/30 SMI"
# -----------------------------------------------------------------------------
#
#  Copyright 2001-2004 Sun Microsystems, Inc. All rights reserved.
#
# -----------------------------------------------------------------------------

package JDK;

use strict;
use variables;

#--------------------------------------------------------------
#
# installation of JDK packages on MEN
#
#--------------------------------------------------------------

sub men_jdk {

  ($NODE_ID) = @_;
    
  if (! $USE_SOLARIS_DISTRIB) {
    my $hostname = COMMON::get_external_name($NODE_ID);
    my $packages = COMPONENT::get_info_men_component("JDK", "PACKAGE");
    COMMON::print_log("\n");
    COMMON::print_log("WARNING: Installation of JDK skipped\n");
    COMMON::print_log("- Please check that required package ($packages) is installed on $hostname\n");
    COMMON::print_log("\n");
    return;
  }

  COMMON::print_stage_node("JDK installation") ;
  COMPONENT::install_men_component ($NODE_ID, "JDK", "");
}

#--------------------------------------------------------------
#
# installation of JDK packages on dataless
#
#--------------------------------------------------------------

sub dataless_jdk {

  ($NODE_ID) = @_;
    
  if (! $USE_SOLARIS_DISTRIB) {
    my $hostname = COMMON::get_external_name($NODE_ID);
    my $packages = COMPONENT::get_info_dataless_component("JDK", "PACKAGE");
    COMMON::print_log("\n");
    COMMON::print_log("WARNING: Installation of JDK skipped\n");
    COMMON::print_log("- Please check that required package ($packages) is installed on $hostname\n");
    COMMON::print_log("\n");
    return;
  }

  COMMON::print_stage_node("JDK installation") ;
  COMPONENT::install_dataless_component ($NODE_ID, "JDK", "");
}

#--------------------------------------------------------------
#
# installation of JDK packages on diskless
#
#--------------------------------------------------------------

sub diskless_jdk {

  ($NODE_ID) = @_;

  if (! $USE_SOLARIS_DISTRIB) {
    my $packages = COMPONENT::get_info_diskless_component("JDK", "PACKAGE");
    COMMON::print_log("\n");
    COMMON::print_log("WARNING: Installation of JDK skipped\n");
    COMMON::print_log("- Please check that required package ($packages) is installed on each diskless specific directories\n");
    COMMON::print_log("\n");
    return;
  }
  
  # diskless environment is set only on the first MEN at the first installation
  if ( $NODE_ID eq $MEN1_ID ) {
    COMMON::print_stage_node("JDK installation for diskless");
    COMPONENT::install_diskless_component($NODE_ID, "JDK", "");
  }
}

{
}



