#!/usr/bin/perl
# -----------------------------------------------------------------------------
#  ident "@(#)sequencer.pl 1.23 04/09/30 SMI"
# -----------------------------------------------------------------------------
#
#  Copyright 2001-2004 Sun Microsystems, Inc. All rights reserved.
#
# -----------------------------------------------------------------------------

package SEQUENCER;

use strict;
no strict "refs";
use variables;

#
# PERL module description
#
#    index:   name of the module
#
#    perl:    name of the PERL script
#    package: name of the package defined in the PERL script
# 

my %module_array =
  (      
   "dialog"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/lib/dialog.pl",
    "package" => "DIALOG",
   } ,
   
   "wait_boot"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/lib/wait_boot.pl",
    "package" => "WAIT_BOOT",
   } ,
   
   "wait_sndr"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/lib/wait_sndr.pl",
    "package" => "WAIT_SNDR",
   } ,
   
   "reboot"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/lib/reboot.pl",
    "package" => "REBOOT",
   } ,

   "addon"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/lib/addon.pl",
    "package" => "ADDON",
   } ,
   
   "mount_men"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/lib/mount_men.pl",
    "package" => "MOUNT_MEN",
   } ,

   "mount_for_diskless"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/lib/mount_for_diskless.pl",
    "package" => "MOUNT_FOR_DISKLESS",
   } ,

   "install_server"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/install_server.pl",
    "package" => "INSTALL_SERVER",
   } ,
   
   "sol_jumpstart"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/sol_jumpstart.pl",
    "package" => "SOL_JUMPSTART",
   } ,
   
   "men_getinfo"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/men_getinfo.pl",
    "package" => "MEN_GETINFO",
   } ,

   "local_check"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/local_check.pl",
    "package" => "LOCAL_CHECK",
   } ,
   
   "men_svm"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/men_svm.pl",
    "package" => "MEN_SVM",
   } ,
   
   "soladd"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/soladd.pl",
    "package" => "SOLADD",
   } ,
   
   "checker"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/checker.pl",
    "package" => "CHECKER",
   } ,
   
   "men_dcss"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/men_dcss.pl",
    "package" => "MEN_DCSS",
   } ,
   
   "local_cgtp"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/local_cgtp.pl",
    "package" => "LOCAL_CGTP",
   } ,

   "men_cmm"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/men_cmm.pl",
    "package" => "MEN_CMM",
   } ,

   "dataless_cmm"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/dataless_cmm.pl",
    "package" => "DATALESS_CMM",
   } ,

   "diskless_cmm"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/diskless_cmm.pl",
    "package" => "DISKLESS_CMM",
   } ,

   "men_rnfs"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/men_rnfs.pl",
    "package" => "MEN_RNFS",
   } ,

   "pmd"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/pmd.pl",
    "package" => "PMD",
   } ,

   "men_nsm"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/men_nsm.pl",
    "package" => "MEN_NSM",
   } ,

   "men_rbs"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/men_rbs.pl",
    "package" => "MEN_RBS",
   } ,

   "men_fsconf"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/men_fsconf.pl",
    "package" => "MEN_FSCONF",
   } ,

   "dataless_fsconf"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/dataless_fsconf.pl",
    "package" => "DATALESS_FSCONF",
   } ,

   "jdk"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/jdk.pl",
    "package" => "JDK",
   } ,

   "ma_jdmk"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/ma_jdmk.pl",
    "package" => "MA_JDMK",
   } ,

   "men_manpages"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/men_manpages.pl",
    "package" => "MEN_MANPAGES",
   } ,

   "local_end"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/local_end.pl",
    "package" => "LOCAL_END",
   } ,

   "wdt"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/wdt.pl",
    "package" => "WDT",
   } ,

   "diskless_solaris"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/diskless_solaris.pl",
    "package" => "DISKLESS_SOLARIS",
   } ,

   "diskless_sm"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/diskless_sm.pl",
    "package" => "DISKLESS_SM",
   } ,

   "diskless_rbs"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/diskless_rbs.pl",
    "package" => "DISKLESS_RBS",
   } ,

   "diskless_cgtp"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/diskless_cgtp.pl",
    "package" => "DISKLESS_CGTP",
   } ,

   "diskless_fsconf"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/diskless_fsconf.pl",
    "package" => "DISKLESS_FSCONF",
   } ,

   "diskless_end"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/diskless_end.pl",
    "package" => "DISKLESS_END",
   } ,

   "ins_soldistrib"=> 
   {
    "perl"    => "$ENV{NHINSTALL_LIB}/tools/install_os/common/ins_soldistrib.pl",
    "package" => "INS_SOLDISTRIB",
   } ,
   )
;

#


#
# ACTION decription
#
#    index:    name of the action
#
#    module:   name of the module (entry in module_array)
#    init:     function executing intialisation action
#    action:   function executing nominal case
#    recovery: function executing recovery action
#    end:      function executing final action
#
my %action_array =
  (
   "check_installer" =>
   {
    "module"   => "install_server",
    "action"   => "check_installer",
   },

   "configure_nic" =>
   {
    "module"   => "install_server",
    "action"   => "configure_iface",
   },

   "get_install_server_info" =>
   {
    "module"   => "install_server",
    "action"   => "get_install_server_info",
   },

   "prepare_directories" =>
   {
    "module"   => "install_server",
    "action"   => "prepare_directories",
   },

   "prepare_jumpstart" =>
   {
    "module"   => "sol_jumpstart",
    "action"   => "prepare_jumpstart",
   },
   
   "ask_for_boot" =>
   {
    "module"   => "dialog",
    "action"   => "ask_for_boot",
   },

   "ask_for_solaris_installation" =>
   {
    "module"   => "dialog",
    "action"   => "ask_for_solaris_installation",
   },

   "ask_for_diskless" =>
   {
    "module"   => "dialog",
    "action"   => "ask_for_diskless",
   },

   "men_wait" =>
   {
    "module"   => "wait_boot",
    "action"   => "node_boot_wait",
   },

   "dataless_wait" =>
   {
    "module"   => "wait_boot",
    "action"   => "node_boot_wait",
   },

   "wait_sndr" =>
   {
    "module"   => "wait_sndr",
    "action"   => "men_wait_sndr",
   },

   "men_getinfo" =>
   {
    "module"   => "men_getinfo",
    "action"   => "men_getinfo",
   },

   "local_check_solaris" =>
   {
    "module"   => "local_check",
    "action"   => "local_check_solaris",
   },

   "local_get_solaris" =>
   {
    "module"   => "local_check",
    "action"   => "local_get_solaris",
   },

   "local_check_nhas" =>
   {
    "module"   => "local_check",
    "action"   => "local_check_nhas",
   },

   "men_svm" =>
   {
    "module"   => "men_svm",
    "action"   => "men_svm",
    "recovery" => "recovery_men_svm",
   },

   "men_soladd" =>
   {
    "module"   => "soladd",
    "action"   => "men_soladd",
    "recovery" => "recovery_men_soladd",
   },

   "dataless_soladd" =>
   {
    "module"   => "soladd",
    "action"   => "dataless_soladd",
    "recovery" => "recovery_dataless_soladd",
   },

   "diskless_soladd" =>
   {
    "module"   => "soladd",
    "action"   => "diskless_soladd",
    "recovery" => "recovery_diskless_soladd",
   },

   "men_checker" =>
   {
    "module"   => "checker",
    "action"   => "men_checker",
   },

   "dataless_checker" =>
   {
    "module"   => "checker",
    "action"   => "dataless_checker",
   },

   "diskless_checker" =>
   {
    "module"   => "checker",
    "action"   => "diskless_checker",
   },

   "men_cgtp" =>
   {
    "module"   => "local_cgtp",
    "action"   => "men_cgtp",
    "recovery" => "recovery_men_cgtp",
   },

   "dataless_cgtp" =>
   {
    "module"   => "local_cgtp",
    "action"   => "dataless_cgtp",
    "recovery" => "recovery_dataless_cgtp",
   },

   "diskless_cgtp" =>
   {
    "module"   => "diskless_cgtp",
    "action"   => "diskless_cgtp",
    "recovery" => "recovery_diskless_cgtp",
   },

   "local_net_configure" =>
   {
    "module"   => "local_cgtp",
    "action"   => "local_net_configure",
   },

   "local_cgtp_add_nodes" =>
   {
    "module"   => "local_cgtp",
    "action"   => "local_cgtp_add_nodes",
   },

   "men_cmm" =>
   {
    "module"   => "men_cmm",
    "action"   => "men_cmm",
    "recovery" => "recovery_men_cmm",
   },

   "men_cmm_add_nodes" =>
   {
    "module"   => "men_cmm",
    "action"   => "men_cmm_add_nodes",
   },

   "men_cmm_reload_file" =>
   {
    "module"   => "men_cmm",
    "action"   => "men_cmm_reload_file",
   },

   "men_rnfs" =>
   {
    "module"   => "men_rnfs",
    "action"   => "men_rnfs",
    "recovery" => "recovery_men_rnfs",
   },

   "men_pmd" =>
   {
    "module"   => "pmd",
    "action"   => "men_pmd",
   },

   "dataless_pmd" =>
   {
    "module"   => "pmd",
    "action"   => "dataless_pmd",
   },

   "diskless_pmd" =>
   {
    "module"   => "pmd",
    "action"   => "diskless_pmd",
   },

   "men_nsm" =>
   {
    "module"   => "men_nsm",
    "action"   => "men_nsm",
   },

   "men_wdt" =>
   {
    "module"   => "wdt",
    "action"   => "men_wdt",
   },

   "dataless_wdt" =>
   {
    "module"   => "wdt",
    "action"   => "dataless_wdt",
   },

   "diskless_wdt" =>
   {
    "module"   => "wdt",
    "action"   => "diskless_wdt",
   },

   "men_rbs" =>
   {
    "module"   => "men_rbs",
    "action"   => "men_rbs",
   },

   "men_fsconf" =>
   {
    "module"   => "men_fsconf",
    "action"   => "men_fsconf",
   },

   "dataless_fsconf" =>
   {
    "module"   => "dataless_fsconf",
    "action"   => "dataless_fsconf",
   },

   "men_fsconf_add_nodes" =>
   {
    "module"   => "men_fsconf",
    "action"   => "men_fsconf_add_nodes",
   },

   "men_jdk" =>
   {
    "module"   => "jdk",
    "action"   => "men_jdk",
   },

   "dataless_jdk" =>
   {
    "module"   => "jdk",
    "action"   => "dataless_jdk",
   },

   "dataless_cmm" =>
   {
    "module"   => "dataless_cmm",
    "action"   => "dataless_cmm",
   },

   "diskless_jdk" =>
   {
    "module"   => "jdk",
    "action"   => "diskless_jdk",
   },

   "men_ma_jdmk" =>
   {
    "module"   => "ma_jdmk",
    "action"   => "men_ma_jdmk",
    "recovery" => "recovery_men_ma_jdmk",
   },

   "dataless_ma_jdmk" =>
   {
    "module"   => "ma_jdmk",
    "action"   => "dataless_ma_jdmk",
   },

   "men_manpages" =>
   {
    "module"   => "men_manpages",
    "action"   => "men_manpages",
   },

   "diskless_solaris" =>
   {
    "module"   => "diskless_solaris",
    "action"   => "diskless_solaris",
    "recovery" => "recovery_diskless_solaris",
   },

   "diskless_sm" =>
   {
    "module"   => "diskless_sm",
    "init"     => "save_files",
    "action"   => "diskless_sm",
    "end"      => "restore_files",
    "recovery" => "recovery_diskless_sm",
   },

   "diskless_rbs" =>
   {
    "module"   => "diskless_rbs",
    "action"   => "diskless_rbs",
    "recovery" => "recovery_diskless_rbs",
   },

   "diskless_rbs_add_nodes" =>
   {
    "module"   => "diskless_rbs",
    "action"   => "diskless_rbs_add_nodes",
   },

   "men_dcss" =>
   {
    "module"   => "men_dcss",
    "action"   => "men_dcss",
   },

   "diskless_net_configure" =>
   {
    "module"   => "diskless_cgtp",
    "action"   => "diskless_net_configure",
   },

   "diskless_cgtp_add_nodes" =>
   {
    "module"   => "diskless_cgtp",
    "action"   => "diskless_cgtp_add_nodes",
   },

   "diskless_cmm" =>
   {
    "module"   => "diskless_cmm",
    "action"   => "diskless_cmm",
    "recovery" => "recovery_diskless_cmm",
   },

   "diskless_fsconf" =>
   {
    "module"   => "diskless_fsconf",
    "action"   => "diskless_fsconf",
   },

   "diskless_reset_men1_dfstab" =>
   {
    "module"   => "diskless_fsconf",
    "action"   => "diskless_reset_men1_dfstab",
   },

   "diskless_ma_jdmk" =>
   {
    "module"   => "ma_jdmk",
    "action"   => "diskless_ma_jdmk",
   },

   "diskless_end" =>
   {
    "module"   => "diskless_end",
    "action"   => "diskless_end",
   },

   "men_addon_solaris" =>
   {
    "module"   => "addon",
    "action"   => "men_addon_solaris",
    "recovery" => "recovery_men_addon_solaris",
   },

   "dataless_addon_solaris" =>
   {
    "module"   => "addon",
    "action"   => "dataless_addon_solaris",
    "recovery" => "recovery_dataless_addon_solaris",
   },

   "diskless_addon_install" =>
   {
    "module"   => "addon",
    "action"   => "diskless_addon_install",
    "recovery" => "recovery_diskless_addon_install",
   },

   "diskless_addon_solaris" =>
   {
    "module"   => "addon",
    "action"   => "diskless_addon_solaris",
    "recovery" => "recovery_diskless_addon_solaris",
   },

   "men_addon_fs" =>
   {
    "module"   => "addon",
    "action"   => "men_addon_fs",
    "recovery" => "recovery_men_addon_fs",
   },

   "dataless_addon_fs" =>
   {
    "module"   => "addon",
    "action"   => "dataless_addon_fs",
    "recovery" => "recovery_dataless_addon_fs",
   },

   "diskless_addon_fs" =>
   {
    "module"   => "addon",
    "action"   => "diskless_addon_fs",
    "recovery" => "recovery_diskless_addon_fs",
   },

   "mount_men" =>
   {
    "module"   => "mount_men",
    "action"   => "mount_men",
   },

   "mount_for_diskless" =>
   {
    "module"   => "mount_for_diskless",
    "action"   => "mount_for_diskless",
   },

   "men_end" =>
   {
    "module"   => "local_end",
    "action"   => "men_end",
   },

   "dataless_end" =>
   {
    "module"   => "local_end",
    "action"   => "dataless_end",
   },

   "men_reboot_for_diskless" =>
   {
    "module"   => "reboot",
    "action"   => "reboot",
   },

   "men_reboot_end" =>
   {
    "module"   => "reboot",
    "action"   => "reboot",
   },

   "dataless_reboot_end" =>
   {
    "module"   => "reboot",
    "action"   => "reboot",
   },

   "men_manual_reboot_for_diskless" =>
   {
    "module"   => "dialog",
    "action"   => "ask_for_men_reboot",
   },

   "men_manual_reboot_end" =>
   {
    "module"   => "dialog",
    "action"   => "ask_for_men_reboot",
   },

   "dataless_manual_reboot_end" =>
   {
    "module"   => "dialog",
    "action"   => "ask_for_dataless_reboot",
   },

   "boot_diskless" =>
   {
    "module"   => "dialog",
    "action"   => "boot_diskless",
   },

   "check_solaris_distrib" =>
   {
    "module"   => "ins_soldistrib",
    "action"   => "check_solaris_distrib",
   },

   "get_solaris_distrib" =>
   {
    "module"   => "ins_soldistrib",
    "action"   => "get_solaris_distrib",
   },
  ) 
;




my %data_array = ();

my $install_status_file;

my $action_forced="";


#--------------------------------------------------------------
#
#  load_state
#
#   load the current state of the installation
#
#--------------------------------------------------------------

sub load_state {

  my $type;
  my $name;
  my $param;
  my $value;

  COMMON::var_defined("NHINSTALL_STATUS_FILE", "", \$install_status_file);
  if (! -f $install_status_file) {
    return ;
  }

  open(INSTALL_STATUS,"<$install_status_file");
  while(<INSTALL_STATUS>) {
    chomp();
    ($type, $name, $param, $value) = split(/,/,$_);
    if ($type eq "ACTION") {
      $action_array{$name}->{last_step}[$param] = $value;
    } else {
      $data_array{$name}->{value} = $value;
    }
  }

  close(INSTALL_STATUS);
}

#--------------------------------------------------------------
#
#  set_progress
#
#  update the progress state (in the installation status file
#  and in the array)
#
#--------------------------------------------------------------

sub set_progress {
  my ($action_name, $param, $step) = @_;

  open(INSTALL_STATUS,">>$install_status_file");

  print INSTALL_STATUS "ACTION,$action_name,$param,$step\n" ;
  $action_array{$action_name}->{last_step}[$param] = $step;

  close(INSTALL_STATUS);
}

#--------------------------------------------------------------
#
#  set_data
#
#  save data into the installation status file
#
#--------------------------------------------------------------

sub set_data {
  my ($data_name, $value) = @_;

  open(INSTALL_STATUS,">>$install_status_file");

  print INSTALL_STATUS "DATA,$data_name,-,$value\n" ;
  $data_array{$data_name}->{value} = $value;

  close(INSTALL_STATUS);
}

#--------------------------------------------------------------
#
#  get_data
#
#  return the data value
#
#--------------------------------------------------------------

sub get_data {
  my ($data_name) = @_;

  if (defined($data_array{$data_name})) {
    return $data_array{$data_name}->{value};
  } else {
    return "";
  }
}

#--------------------------------------------------------------
#
#  is_last_step
#
#  return true if the action is at the current step
#
#--------------------------------------------------------------

sub is_last_step {
  my ($action_name, $param, $step) = @_ ;

  
  if (! defined($action_array{$action_name}->{last_step}[$param])) {
    $action_array{$action_name}->{last_step}[$param] = "";
  }

  if ($action_array{$action_name}->{last_step}[$param] eq $step) {
    return 1;
  }

  return 0;
}

#--------------------------------------------------------------
#
#  load modules
#
#   load all PERL module defined in the module array
#
#--------------------------------------------------------------

sub load_modules {

  foreach my $module (keys %module_array) {
    my $perl=$module_array{$module}->{perl} ;
    require "$perl";
  }
}

#--------------------------------------------------------------
#
#    execute a step
#
#    execute the given step for a given action
#    undefined step are skipped
#
#--------------------------------------------------------------

sub execute_step {
  my ($action_name, $param, $step, $function) = @_ ;

  my $module = $action_array{$action_name}->{module};
  if (!defined($module)) {
    print "error: no module defined for action $action_name\n";
    exit 1;
  }
  
  my $package = $module_array{$module}->{package};

  # step is executed only if it is defined and not null

  if (defined($action_array{$action_name}->{$step})) {
    if ($action_array{$action_name}->{$step} ne "") {

      my $func = $package . "::" . $action_array{$action_name}->{$step};
      if ($step eq "action") {
	set_progress($action_name, $param, "running") ;
      }
      COMMON::print_debug($DEBUG_ACTION, "calling $func($param)");
      &$func($param) ;

    }
  }

  # set even if no step defined to activate next step
  set_progress($action_name, $param, $step);
}

#--------------------------------------------------------------
#
#    execute an action
#
#--------------------------------------------------------------

sub execute_action {

  my ($action_name, $param) = @_ ;

  if (!defined($param) || ($param eq "")) {
    $param = 0;
  }
  

  if (!defined($action_array{$action_name})) {
    COMMON::error("SEQUENCER: action $action_name unknown") ;
    return;
  }

  if (($TESTING ne "recovery") && ($TESTING ne "interrupt")) {

    #
    # normal case
    #
    # if action was running, the recovery is performed
    #

    if (is_last_step($action_name, $param, "running") || is_last_step($action_name, $param,"recovery")) {
      # failure during execution or during recovery
      # we execute (or re-execute) the recovery action
      # and reset the progress indicator to "init done"
      execute_step($action_name, $param, "recovery");
      set_progress($action_name, $param, "init");

      # the recovery indicator is reset
      $RECOVERY = $FALSE;
    }
    
    if (is_last_step($action_name,$param,"")) {
      execute_step($action_name, $param, "init");
    }
    if (is_last_step($action_name,$param, "init")) {
      execute_step($action_name, $param, "action");
    }
    if (is_last_step($action_name, $param, "action")) {
      execute_step($action_name, $param, "end");
    }


  } elsif ($TESTING eq "recovery") {
    
    #
    # instrumentation for recovery testing
    #
    #
    # if a recovery action is defined:
    # - action is executed
    # - recovery is then called
    # - action is re-executed again
    #
    # if no recovery is defined
    # - action is executed
    # - action is re-executed: this checks that the action
    #   can be executed twice without a recovery need
    
    if (is_last_step($action_name, $param, "running") || is_last_step($action_name, $param,"recovery")) {
      # failure during execution or during recovery
      # we execute (or re-execute) the recovery action
      # and reset the progress indicator to "init done"
      execute_step($action_name, $param, "recovery");
      set_progress($action_name, $param, "init");

      # the recovery indicator is reset
      $RECOVERY = $FALSE;
    }

    if (is_last_step($action_name,$param,"")) {
      execute_step($action_name, $param, "init");
    }
    if (is_last_step($action_name,$param, "init")) {
      execute_step($action_name, $param, "action");
      set_progress($action_name, $param, "action_1");
    }
    if (is_last_step($action_name,$param, "action_1")) {
      execute_step($action_name, $param, "recovery");
      set_progress($action_name, $param, "recovery");
    }
    if (is_last_step($action_name,$param, "recovery")) {
      execute_step($action_name, $param, "action");
      set_progress($action_name, $param, "action_2");
    }
    if (is_last_step($action_name, $param, "action_2")) {
      execute_step($action_name, $param, "end");
    }

  } elsif ($TESTING eq "interrupt") {

    #
    # the first time, execute the action and stop execution with exit status 2
    # the second time, execute the recovery then the action again and continue
    # 
    if (is_last_step($action_name, $param, "running") || is_last_step($action_name, $param,"recovery")) {
      # failure during execution or during recovery
      # we execute (or re-execute) the recovery action
      # and reset the progress indicator to "init done"
      execute_step($action_name, $param, "recovery");
      set_progress($action_name, $param, "init");

      # the recovery indicator is reset
      $RECOVERY = $FALSE;
    }
    if (is_last_step($action_name, $param, "exit")) {
      # interruption has been force: perform recovery, the action
      execute_step($action_name, $param, "recovery");
      set_progress($action_name, $param, "after_exit");

      # the recovery indicator is reset
      $RECOVERY = $FALSE;
    }
    
    if (is_last_step($action_name,$param,"")) {
      execute_step($action_name, $param, "init");
    }
    if (is_last_step($action_name,$param, "init")) {
      execute_step($action_name, $param, "action");
    }
    if (is_last_step($action_name,$param, "action")) {
      if ($action_forced) {
	set_progress($action_name, $param, "after_exit");
      } else {
	set_progress($action_name, $param, "exit");
	exit 2;
      }
    }
    if (is_last_step($action_name,$param, "after_exit")) {
      execute_step($action_name, $param, "action");
      set_progress($action_name, $param, "action_2");
    }
    if (is_last_step($action_name, $param, "action_2")) {
      execute_step($action_name, $param, "end");
    }
  }

}

#--------------------------------------------------------------
#
#    force an action to be executed
#    . recovery is never executed by this way
#    . must be reserved to general initialization action
#
#--------------------------------------------------------------

sub force_action {

  my ($action_name, $param) = @_ ;
  
  if (!defined($action_array{$action_name})) {
    COMMON::error("ERROR: action $action_name unknown"); ;
    return;
  }

  # action_forced is tested when performing interrupt testing
  $action_forced = $TRUE;

  set_progress($action_name, $param, "");
  execute_action($action_name, $param);

  $action_forced = $FALSE;
}

#--------------------------------------------------------------
#
# check action
#
# - check that all functions exist 
#   (init, action, recovery, end)
#
#--------------------------------------------------------------

sub check_action {

  my $ok = $TRUE;

  for my $action_name (keys %action_array) {
    foreach my $step ("init", "action", "recovery", "end") {
      if (defined($action_array{$action_name}->{$step})) {
	my $module = $action_array{$action_name}->{module};
	if (! defined($module_array{$module}->{package})) {
	  $ok = $FALSE;
	  COMMON::print_err("action $action_name, step $step: package unknown\n");
	} else {
	  my $package =$module_array{$module}->{package};
	  my $func = $package . "::" . $action_array{$action_name}->{$step};
	  if (! defined(&$func)) {
	    $ok = $FALSE;
	    COMMON::print_err("action $action_name, step $step: function $func not defined\n");
	  }
	}
      }
    }
  }
  
  if (! $ok) {
    exit 1;
  }
}

#--------------------------------------------------------------
#
#   sequencer initialization
#
#--------------------------------------------------------------

sub init {

  load_modules();
  load_state();
  check_action();
}

{
}
